#!/usr/bin/perl

# $Id: lipm_fasta2seqlen.pl 1613 2018-07-16 15:43:32Z gouzy $

BEGIN
{
	use File::Basename;
	my $dirprg=dirname($0);
	unshift @INC, "$dirprg/../corelib";
	unshift @INC, "$dirprg/../lib";
	$ENV{PATH} .= ":$dirprg";
	$ENV{LANG} = "C";
	$VERSION = do { my @r = (q$Rev: 1613 $ =~ /\d+/g); sprintf "%d."."%02d" x $#r, @r }
}


use strict;
use warnings;
use General;
use GeneralBioinfo;
use ParamParser;
use Data::Dumper;
use Carp;

# svn propset svn:keywords "Id Rev" *.pl

MAIN:
{
	my $o_param = New ParamParser('GETOPTLONG',\&Usage,'in=s','out=s');

	$o_param->AssertFileExists('in');
	$o_param->AssertDefined('out');

	my %h_seq=();
	&FastaToHash($o_param->Get('in'),\%h_seq);
	my $f_out = $o_param->GetStreamOut('out');
	foreach my $id (sort keys(%h_seq))
	{
		print $f_out "$id\t".length($h_seq{$id}{sequence})."\n";
	}
	$f_out->close;
}

sub Usage
{
print STDERR<<END
Convert a fasta file in tabulated file (cf bedtools genomecov)
seq<tab>seqlen 
$0 --in fastafile --out genomecov.tab
END
}

